﻿Imports System.Threading


''' <summary>
''' 
''' </summary>
''' <remarks></remarks>
Public Class frmMain

    'Private registerControls() As CheckBox
    Private registerControls As New Collection

    ' Define the standard interface
    Private WithEvents myInterface As New BVinterface()

    ' Delegate that is used to show incoming data on the form.
    ' Necessary because it comes from another thread, that cannot access the
    ' form's controls directly.
    Delegate Sub SetTextCallback(ByVal text As String)



    ''' <summary>
    ''' The frmMain_Load will initialize the form
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub frmMain_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        ' set initial interface property

        '

        ' SAMPLE CODE FOR BVSYSTEMS.BE:
        'Dim myInterface As New BVinterface()
        '
        'With myInterface
        '    .comPort = "COM10"  ' use COM10
        '    .shiftRegisters = 1 ' use 2 shift registers (16 outputs)
        '    .sendImmediately = True

        '    If .connect() Then
        '        .clearAllOutputs()  ' clear all outputs
        '        .setOutput(8)       ' set output 8

        '        ' run toggling function
        '        For cnt As Integer = 1 To 10
        '            .invertOutput(1)
        '            Thread.Sleep(100)
        '        Next
        '    End If
        'End With
        '
        'Application.Exit()


        With myInterface
            .shiftBitOneFirst = False
            .shiftByteOneFirst = False
        End With

        ' Set listbox styles
        cmbCom.DropDownStyle = ComboBoxStyle.DropDownList
        CmbRegisters.DropDownStyle = ComboBoxStyle.DropDownList

        ' Initialize COM ports
        For comCnt As Integer = 1 To 32
            cmbCom.Items.Add("COM" & comCnt)
        Next
        cmbCom.SelectedIndex = 0

        ' Initialize shift registers
        For sregCnt As Integer = 1 To 15
            CmbRegisters.Items.Add(sregCnt)
        Next
        CmbRegisters.SelectedIndex = 0

        ' load settings
        loadSettings()

    End Sub



    ''' <summary>
    ''' loadSettings() loads the settings from the XML configuration file
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub loadSettings()
        With My.Settings
            cmbCom.Text = .COM
            CmbRegisters.Text = .COUNT
        End With
    End Sub



    ''' <summary>
    ''' saveSettings() saves the settings from the XML configuration file
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub saveSettings()
        With My.Settings
            .COM = cmbCom.Text
            .COUNT = CmbRegisters.Text
        End With
    End Sub



    ''' <summary>
    ''' doConnect() will connect the interface
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub doConnect()
        registerControls = New Collection()
        myInterface.comPort = cmbCom.Text

        ' determine desired number of registers
        Dim numberOfRegisters As Integer = Val(CmbRegisters.Text)
        myInterface.shiftRegisters = numberOfRegisters

        ' Connect the interface card
        myInterface.connect()

        ' Loop through all rows
        For sregCnt As Integer = 0 To (numberOfRegisters - 1)
            ' Loop through all registers (rows)

            Dim textfield As Label = New Label()
            textfield.Text = "OUTPUT " & Format((sregCnt * 8 + 1), "00") & " - " & Format((sregCnt * 8 + 8), "00")
            textfield.Left = 10
            textfield.Top = 25 + 25 * sregCnt

            frameOutputs.Controls.Add(textfield)

            ' Loop through all checkboxes of the selected row
            For sCheckCnt As Integer = 1 To 8
                Dim newCheckBox As CheckBox = New CheckBox()

                With newCheckBox
                    .Width = 15
                    .Text = ""
                    .Top = 20 + (25 * sregCnt)
                    .Left = 20 * sCheckCnt + 100
                End With


                ' Add an event handler
                AddHandler newCheckBox.Click, AddressOf CheckedChanged


                registerControls.Add(newCheckBox)
                frameOutputs.Controls.Add(newCheckBox)
            Next
        Next
    End Sub



    ''' <summary>
    ''' doDisconnect() will disconnect the interface
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub doDisconnect()
        registerControls.Clear()
        frameOutputs.Controls.Clear()
        myInterface.disconnect()
    End Sub




    ' Here we define our shift registers
    Private Sub CmdConnect_Click(sender As System.Object, e As System.EventArgs) Handles CmdConnect.Click

        If CmdConnect.Text = "&Connect" Then
            Try
                CmdConnect.Text = "&Disconnect"
                doConnect()
                cmbCom.Enabled = False
                CmbRegisters.Enabled = False
                saveSettings()
            Catch ex As Exception
                MsgBox("An error occured while connecting to the interface: " & ex.Message, _
                        MsgBoxStyle.OkOnly + MsgBoxStyle.Information, _
                        "Connection Error")
            End Try

        Else
            CmdConnect.Text = "&Connect"
            doDisconnect()
            cmbCom.Enabled = True
            CmbRegisters.Enabled = True
        End If

    End Sub



    ''' <summary>
    ''' CmdSetAll_Click will select all checkboxes
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CmdSetAll_Click(sender As System.Object, e As System.EventArgs) Handles CmdSetAll.Click
        For Each chk As CheckBox In registerControls
            chk.Checked = True
        Next

        ' call the CmdSend_Click method. There is no need to pass any data to it, it isn't
        ' use anyway (I just used the keyword Nothing).
        CmdSend_Click(Nothing, Nothing)
    End Sub



    ''' <summary>
    ''' CmdClearAll_Click will clear all checkboxes
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CmdClearAll_Click(sender As System.Object, e As System.EventArgs) Handles CmdClearAll.Click
        For Each chk As CheckBox In registerControls
            chk.Checked = False
        Next

        ' call the CmdSend_Click method. There is no need to pass any data to it, it isn't
        ' use anyway (I just used the keyword Nothing).
        CmdSend_Click(Nothing, Nothing)
    End Sub



    ''' <summary>
    ''' CmdInvertAll_Click will invert all checkboxes
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CmdInvertAll_Click(sender As System.Object, e As System.EventArgs) Handles CmdInvertAll.Click
        For Each chk As CheckBox In registerControls
            chk.Checked = Not chk.Checked
        Next

        ' call the CmdSend_Click method. There is no need to pass any data to it, it isn't
        ' use anyway (I just used the keyword Nothing).
        CmdSend_Click(Nothing, Nothing)
    End Sub



    ''' <summary>
    ''' CmdSend_Click will send the states to the interface card
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CmdSend_Click(sender As System.Object, e As System.EventArgs) Handles CmdSend.Click
        ' First we need to put all the data into our bInterface object
        Dim bitCounter As Integer = 0
        Dim byteCounter As Integer = 1 ' myInterface.numberOfDataBytes
        Dim currentByte As Byte = 0

        Dim checkCounter As Integer = 0

        ' Temporary disable the sendImmediately function. Otherwise each change of a checkbox
        ' would cause the program to send a new request packet.
        myInterface.sendImmediately = False

        For Each chk As CheckBox In registerControls
            ' loop through every checkbox
            checkCounter = checkCounter + 1
            myInterface.output(checkCounter) = chk.Checked
        Next

        ' Enable the sendImmediately function again
        myInterface.sendImmediately = True

        ' Transmit the data, if possible
        Try
            myInterface.transmitData()
        Catch ex As Exception
            MsgBox("Error: " & ex.Message, _
                    MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, _
                    "Unable to send data")
        End Try


    End Sub



    ''' <summary>
    ''' frmMain_Resize() is called when the form is resized. It will change the dimensions
    ''' of the frames.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub frmMain_Resize(sender As Object, e As System.EventArgs) Handles Me.Resize
        If Me.WindowState <> FormWindowState.Minimized Then
            actionPane.Top = Me.Height - actionPane.Height - 75
            frameOutputs.Height = Me.Height - frameConnection.Height - 190
            Me.Width = 318
        End If
    End Sub



    Private Sub SetText(ByVal caption As String)
        txtResult.Text = caption
    End Sub


    ''' <summary>
    ''' myInterface_feedbackReceived is an event that is generated by the BVinterface class.
    ''' The event is used to catch the incoming data from the interface card.
    ''' </summary>
    ''' <param name="message"></param>
    ''' <remarks></remarks>
    Private Sub myInterface_feedbackReceived(message As String) Handles myInterface.feedbackReceived
        Dim caption As String = Format(Now, "HH:mm:ss") & " " & message
        Dim d As New SetTextCallback(AddressOf SetText)
        Invoke(d, New Object() {caption})
    End Sub



    ''' <summary>
    ''' CheckedChanged() is an event that is called when one of the checkboxes is changed by the
    ''' means of a mouse click.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CheckedChanged(sender As System.Object, e As System.EventArgs)
        ' call the CmdSend_Click method. There is no need to pass any data to it, it isn't
        ' use anyway (I just used the keyword Nothing).
        CmdSend_Click(Nothing, Nothing)
    End Sub
End Class
